
// Copyright (C) Tom Horsley, 1997. All rights reserved.

#include "enable-set-time.h"
#include "lasterr-exception.h"

EnableSetTime::EnableSetTime()
: try_privs(true)
{
   BOOL opt_ok = OpenProcessToken(GetCurrentProcess(),
                                  TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY,
                                  &tok_handle);
   if (! opt_ok) {
      if (GetLastError() == ERROR_CALL_NOT_IMPLEMENTED) {

         // Must be on Win95, not NT - don't throw an exception, just
         // pretend we have the privilege (after all, we do :-).

         SetLastError(ERROR_SUCCESS);
         try_privs = false;
         return;
      }
      throw LastErrorException("OpenProcessToken");
   }
   memset((void *)&tok_priv, 0, sizeof(tok_priv));
   LookupPrivilegeValue(NULL, SE_SYSTEMTIME_NAME,
                        &tok_priv.Privileges[0].Luid);
   tok_priv.PrivilegeCount = 1;
   tok_priv.Privileges[0].Attributes |= SE_PRIVILEGE_ENABLED;
   AdjustTokenPrivileges(tok_handle, FALSE, &tok_priv, 0, NULL, 0);
   if (GetLastError() != ERROR_SUCCESS) {
      throw LastErrorException("AdjustTokenPrivileges");
   }
}

EnableSetTime::~EnableSetTime()
{
   if (try_privs) {
      tok_priv.Privileges[0].Attributes &= (~ SE_PRIVILEGE_ENABLED);
      AdjustTokenPrivileges(tok_handle, FALSE, &tok_priv, 0, NULL, 0);
   }
}
