#ifndef ntp_service_h
#define ntp_service_h

// Copyright (C) Tom Horsley, 1997. All rights reserved.

#include "wrap-service.h"
#include "wrap-critical.h"

class LogStuff;
class NtpLongFixed;

class NtpService : public WrapService {
public:

   NtpService(HINSTANCE init_hInstance);

   virtual
   ~NtpService();

   virtual void
   Run();

   virtual bool
   OnInit();

   virtual void
   OnStop();

   virtual void
   OnInterrogate();

   virtual void
   OnPause();

   virtual void
   OnContinue();

   virtual void
   OnShutdown();

   virtual bool
   OnUserControl(DWORD user_opcode);

   virtual LogStuff *
   GetLog();

   virtual LPCTSTR
   GetDependencyList();

   static char * ntpversion;

private:

   bool
   IsRasActive();

   void
   TryOnce();

   void
   LogTimeDiff(const char * msg, NtpLongFixed & t);

   bool         wait_for_ras;
   bool         ras_dll_loaded;
   HINSTANCE    ras_dll_handle;
   FARPROC      ras_enum_connections_ptr;
   FARPROC      ras_get_connection_status_ptr;
   bool         run_once;
   bool         write_log;
   volatile bool shutting_down;
   DWORD        ras_poll_milliseconds;
   DWORD        ntp_poll_milliseconds;
   char *       ntp_server_name;
   unsigned short ntp_server_port;
   char *       log_directory_name;
   DWORD        max_adjust_seconds;
   LogStuff *   logger;

   HANDLE       stop_event;

   DeclareCriticalSection run_lock;
};

#endif // ntp_service_h
