
// Copyright (C) Tom Horsley, 1997. All rights reserved.

#include "wrap-winsock.h"
#include "lasterr-exception.h"
#include "simple-exception.h"

WrapWinsock::WrapWinsock(int major_version, int minor_version)
: should_call_shutdown(false)
{
   WORD wVersionRequested;
   WSADATA wsaData;

   wVersionRequested = MAKEWORD(major_version, minor_version);
   if (WSAStartup(wVersionRequested, &wsaData) != 0) {
      LastErrorException ee("WSAStartup");
      throw ee;
   }
   should_call_shutdown = true;

   // Confirm that the Windows Sockets DLL supports requested version

   if ( LOBYTE( wsaData.wVersion ) != major_version ||
           HIBYTE( wsaData.wVersion ) != minor_version ) {
       SimpleException ee("WSAStartup: Winsock version not available");
       throw ee;
   }
}

WrapWinsock::~WrapWinsock()
{
   if (should_call_shutdown) {
      WSACleanup();
   }
}
